#
# spec file for package sysvinit (Version 2.78.4)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         sysvinit
%define MGVER  0.9.4b
%define PDVER  2.0.2
%define KPVER  2.02
%define SCVER  1.0
Copyright:    1991-1995 Miquel van Smoorenburg
Group:        System Environment/Base
Autoreqprov:  on
Version:      2.78.4
Release:      114
Summary:      SysV-Style init
Source:  sysvinit-2.78.4.tar.bz2
Source1: mingetty-0.9.4b.tar.bz2
Source2: killproc-2.02.tar.bz2
Source3: powerd-2.0.2.tar.bz2
Source4: showconsole-1.0.tar.bz2
Patch:   sysvinit-2.78.4.dif
Patch1:  mingetty-0.9.4b.dif
Patch2:  powerd-2.0.2.dif
Patch3:  killproc-2.02.dif
Patch4:  swsusp-for-sysvinit-2.78.diff
Patch5:  sysvinit-2.78-sulogin.patch
Patch6:  sysvinit-2.78-startstop.patch
Patch7:  sysvinit-2.78-suse.patch
Patch8:  sysvinit-2.78-paths.patch
Patch9:  sysvinit-2.78-msgs.patch
Patch10:  showconsole-1.0.dif
Patch11: sysvinit-2.78.4-race.patch

%description
System V style init programs by Miquel van Smoorenburg that control
the booting and shutdown of your system. These support a number of
system runlevels, each one associated with a specific set of utilities. For
example, normal system runlevel is 3, which starts a getty on
virtual consoles tty1-tty6. Runlevel 5 starts xdm. Runlevel 0 shuts
down the system.
See the individual man pages for: inittab, initscript, halt,
init, killproc, killall5, powerd, reboot, runlevel, shutdown, and telinit.

Authors:
--------
    Miquel van Smoorenburg <miquels@drinkel.ow.nl>
    Florian La Roche <florian@suse.de>
    Werner Fink <werner@suse.de>

SuSE series: a

%prep
%setup -b 1 -b 2 -b 3 -b 4
%patch -P 5 -b .sulogin
%patch -P 6 -b .ststdmn
%patch -P 7 -b .suse
%patch -P 8 -b .paths
%patch -P 11 -b .race
%patch
%patch -P 4 -p 1
%patch -P 9 -b .msgs
cd ../mingetty-%{MGVER}
%patch -P 1
cd ../powerd-%{PDVER}
%patch -P 2
cd ../killproc-%{KPVER}
%patch -P 3
cd ../showconsole-%{SCVER}
%patch -P 10

%build
RPM_OPT_FLAGS="${RPM_OPT_FLAGS} -D_FILE_OFFSET_BITS=64"
export RPM_OPT_FLAGS
CFLAGS="-Wall ${RPM_OPT_FLAGS} -D_GNU_SOURCE -D__NO_STRING_INLINES -pipe"
CC=gcc
make -C src CFLAGS="$CFLAGS" CC="$CC"
pushd contrib/
    $CC $CFLAGS -o start-stop-daemon start-stop-daemon.c
popd
%ifnarch s390x
cd ../showconsole-%{SCVER}
make
%endif
cd ../killproc-%{KPVER}
make INC="-I../showconsole-%{SCVER} -L../showconsole-%{SCVER}"
cd ../mingetty-%{MGVER}
make
cd ../powerd-%{PDVER}
./configure --prefix= --bindir=/sbin --mandir=/usr/share/man --infodir=/usr/share/info
make CFLAGS="-I../sysvinit-%{version}/src $CFLAGS"

%install
make install -C src MANPATH=%{_mandir}
install -s contrib/start-stop-daemon /sbin/
%ifnarch s390x
cd ../showconsole-%{SCVER}
make install
%endif
cd ../mingetty-%{MGVER}
make install
cd ../killproc-%{KPVER}
make install
cd ../powerd-%{PDVER}
make install
install powerd.8 /usr/share/man/man8
cp README README.powerd
cp SUPPORTED SUPPORTED.powerd
cp FAQ FAQ.powerd
test -p /dev/initctl || {
    rm -f /dev/initctl
    mknod /dev/initctl p
    chmod 600 /dev/initctl
}
echo '# ' > /etc/powerd.conf
echo '# /etc/powerd.conf  for powerd version-2.02' >> /etc/powerd.conf
echo '# ' >> /etc/powerd.conf
echo '# read manual page of detectups(8) and powerd(8) its self.' >> /etc/powerd.conf
echo '# ' >> /etc/powerd.conf
gzip -9f %{_mandir}/man?/*.[1-8]
%ifarch sparc
(cd /usr/bin; ln -sf ../../sbin/shutdown .)
%endif

%post
#!/bin/sh
if [ ! -p dev/initctl ] ; then
  mknod -m 0600 dev/initctl p
fi
if [ ! -p dev/blog ] ; then
  mknod -m 0640 dev/blog p
fi

%files
%ifnarch s390
%config /etc/powerd.conf
%doc ../powerd-%{PDVER}/README.powerd
%doc ../powerd-%{PDVER}/SUPPORTED.powerd
%doc ../powerd-%{PDVER}/FAQ.powerd
%doc ../powerd-%{PDVER}/powerd.conf.monitor
%doc ../powerd-%{PDVER}/powerd.conf.peer
%doc README.swsusp
%endif
%doc contrib/start-stop-daemon.README
# %doc contrib/bootlogd.README
%ghost /dev/initctl
/bin/usleep
# /sbin/bootlogd
/sbin/blogger
%ifnarch s390x
/sbin/blogd
/sbin/showconsole
/sbin/setconsole
%endif
/sbin/checkproc
/sbin/pidofproc
/sbin/halt
/sbin/init
# /sbin/intr
/sbin/killproc
/sbin/killall5
/sbin/mingetty
/sbin/pidof
%ifnarch s390
/sbin/powerd
/sbin/detectups
/sbin/poweroff
/sbin/swsusp
%endif
/sbin/reboot
/sbin/runlevel
/sbin/startproc
/sbin/start_daemon
/sbin/shutdown
/sbin/start-stop-daemon
/sbin/sulogin
/sbin/telinit
/usr/bin/last
/usr/bin/lastb
/usr/bin/utmpdump
%ifarch sparc
/usr/bin/shutdown
%endif
# /usr/include/libblogger.h
# /usr/lib/libblogger.a
%doc %{_mandir}/man1/last.1.gz
%doc %{_mandir}/man1/lastb.1.gz
%doc %{_mandir}/man1/usleep.1.gz
# %doc %{_mandir}/man8/bootlogd.8.gz
%doc %{_mandir}/man8/blogger.8.gz
%ifnarch s390x
%doc %{_mandir}/man8/blogd.8.gz
%doc %{_mandir}/man8/showconsole.8.gz
%doc %{_mandir}/man8/setconsole.8.gz
%endif
%doc %{_mandir}/man8/checkproc.8.gz
%doc %{_mandir}/man8/pidofproc.8.gz
%doc %{_mandir}/man8/halt.8.gz
%doc %{_mandir}/man5/initscript.5.gz
%doc %{_mandir}/man5/inittab.5.gz
%doc %{_mandir}/man8/init.8.gz
#%doc %{_mandir}/man8/intr.8.gz
%doc %{_mandir}/man8/killall5.8.gz
%doc %{_mandir}/man8/killproc.8.gz
%doc %{_mandir}/man8/mingetty.8.gz
%doc %{_mandir}/man8/pidof.8.gz
%ifnarch s390
%doc %{_mandir}/man8/swsusp.8.gz
%doc %{_mandir}/man8/powerd.8.gz
%doc %{_mandir}/man8/poweroff.8.gz
%endif
%doc %{_mandir}/man8/reboot.8.gz
%doc %{_mandir}/man8/runlevel.8.gz
%doc %{_mandir}/man8/startproc.8.gz
%doc %{_mandir}/man8/start_daemon.8.gz
%doc %{_mandir}/man8/shutdown.8.gz
%doc %{_mandir}/man8/sulogin.8.gz
%doc %{_mandir}/man8/telinit.8.gz

%changelog -n sysvinit
* Tue Sep 25 2001 - werner@suse.de
- Fix race on waiting on console I/O: just try open log file first
* Thu Sep 20 2001 - werner@suse.de
- Ignore interrupted waitpid(2) calls
* Wed Sep 19 2001 - werner@suse.de
- Add forgotten configuration of powerd
* Wed Sep 19 2001 - werner@suse.de
- Update to powerd 2.0.2 because this version initialize the
  serial interface which seems to be required for kernel 2.4.x
* Fri Sep 07 2001 - werner@suse.de
- startproc: close boot logging FIFO before executing a daemon.
* Wed Sep 05 2001 - werner@suse.de
- blogd: really read the console a half second (bug #9899)
* Tue Sep 04 2001 - werner@suse.de
- Add waitpid() loop nodead lock patch of Andrea
- Add a check in the waitpid() loop to exit on failure
* Thu Aug 30 2001 - werner@suse.de
- Make blogd/showconsole more robustly against errors
- Add some fixes of bug #9898
* Fri Aug 24 2001 - werner@suse.de
- Activate 64 bit file handling interface (large file support)
* Thu Aug 23 2001 - werner@suse.de
- Do not reset terminal device of /dev/console if on a serial line
* Tue Jun 26 2001 - cstein@suse.de
- added a patch for the shutdown messages (see bug #8076)
  (also changed some other strings in shutdown.c)
* Mon Jun 25 2001 - bk@suse.de
- back out read return 0 patch and don't build showconsole on s390x
* Mon Jun 25 2001 - bk@suse.de
- don't include showconsole programs in filelist on s390x
* Fri Jun 22 2001 - bk@suse.de
- blogd: when read return 0, this means EOF - don't loop in this case.
* Tue Jun 12 2001 - bk@suse.de
- don't try to build showconsole on s390x(not supported by kernel)
* Wed May 23 2001 - werner@suse.de
- Do not eat up argv and environ at boot logging in startproc
* Wed May 23 2001 - werner@suse.de
- New killproc version 2.01: now we're able again to find deamons
  based on scripts.
- Make fifo /dev/blog after installation if not exist.
* Tue May 08 2001 - werner@suse.de
- Remove previous barrier() calls but use them on empty loops.
* Wed May 02 2001 - werner@suse.de
- Call umask only once for all init processes (pid 1 and others)
- Add some barrier() against officious compiler
- Rename cpp macro TEST to SYSVINIT_TEST
* Tue Apr 24 2001 - werner@suse.de
- Add default umask 022 at boot time
* Tue Apr 17 2001 - werner@suse.de
- Few minor changes to killproc and co.
* Thu Apr 12 2001 - werner@suse.de
- Disable boot logging and boot message redirection at common
  runlevels if TIOCGDEV is missed.
* Wed Apr 11 2001 - werner@suse.de
- blogd: complain about missing ioctl TIOCGDEV at compile
  and run time
* Wed Apr 04 2001 - werner@suse.de
- After fork reset signal handling of startproc to default for
  common signals
* Thu Mar 22 2001 - werner@suse.de
- Startproc/killproc: handle by RPM moved and deleted exe links
* Wed Mar 21 2001 - werner@suse.de
- Add patch for rlstat() of schowconsole (Andreas Schwab)
* Mon Mar 19 2001 - werner@suse.de
- Startproc/killproc: handle deleted exe links
* Fri Mar 09 2001 - werner@suse.de
- Add forgotten usleep to file list
* Wed Feb 14 2001 - werner@suse.de
- Use sysvinit 2.78.4
- Spilt dif into several patches
- Use static on the most functions of init.c
- Integrate showconsole
- bzip tar's
* Mon Feb 05 2001 - werner@suse.de
- Update of killproc to version 2.00
  * LSB conform exit values
  * Use boot logging provided by showconsole-0.9.tar.gz of aaa_base
  * New program usleep
* Mon Jan 15 2001 - werner@suse.de
- Make strncmp of exe link and fullname working upto MAXNAMLEN
* Tue Jan 09 2001 - werner@suse.de
- Use int instead of kdev_t in bootlogd.c
* Wed Nov 29 2000 - werner@suse.de
- Make tty settings for sulogin working, and enable job control.
- Workaround vor sigfholder (may kernel bug)
* Tue Nov 28 2000 - werner@suse.de
- New and fixed killproc version 1.17
- Change some man pages of sysvinit to fit our new boot scheme
- Enable tty settings for sulogin, should be checked on
  serial console (BTW: SHOULD we DO that?).
* Thu Nov 16 2000 - ro@suse.de
- fixed install for killproc
* Wed Nov 15 2000 - werner@suse.de
- New killproc version (1.16)
  * base name allowed
  * protected the parent of the parent
  * provide pidofproc (a link to checkproc for a verbose checkproc)
  * provide stat_daemon (a link to statproc)
* Mon Oct 23 2000 - werner@suse.de
- changes on mingetty (new version 0.9.4b)
  * On ro files systems chmod/chown shouldn't force an exit.
  * Therefore we need a warn message.
  * Due to the lack of a revoke system call we signal
  all file holders including the mmaping processes.
* Wed Jun 28 2000 - bk@suse.de
- enabled reboot on s390
* Sun Jun 25 2000 - bk@suse.de
- removed some not needed files on s390
* Tue May 30 2000 - werner@suse.de
- Correct path of powerstatus (/var/run/powerstatus) of powerd
* Wed May 24 2000 - garloff@suse.de
- Added minimal docu for swsusp.
* Tue May 23 2000 - werner@suse.de
- New killproc version 1.15 reading exe link for kernel 2.2
* Wed May 17 2000 - garloff@suse.de
- Added software-suspend support to init.
- login option of mingetty limits logname to 42 chars.
* Wed May 10 2000 - garloff@suse.de
- Working patch for mingetty to support devfs.
* Wed May 10 2000 - garloff@suse.de
- Preliminary patch for devfs.
* Wed May 10 2000 - garloff@suse.de
- Make it more secure by passing the logname as one arg and by
  checking for a leading '-'. The manpage tells the sysadmin
  about possible risks now.
* Tue May 09 2000 - garloff@suse.de
- Added new options --login and --logopts to mingetty, so you may
  create an inittab entry using ssh for login or similar
* Tue Mar 07 2000 - werner@suse.de
- Ignore SIGTERM for syslogd because this daemon use that signal
  to control the parent process.
- Make read/write of /etc/ioctrl.save EINTR safe
- Use defined special character given from <termios.h>
- No flow control (-ixon), ignore break (ignbrk), and make nl/cr
  more usable (sane).
- Set the terminal line immediately
* Mon Mar 06 2000 - werner@suse.de
- Avoid script handling for kernel threads
* Sun Mar 05 2000 - werner@suse.de
- If open fails -1 is returned (close bug #2200)
* Fri Mar 03 2000 - kukuk@suse.de
- Create /usr/bin/shutdown link for UltraSPARC kernel
* Mon Feb 21 2000 - werner@suse.de
- New version of killproc (1.1.4): fix of script handling
- New version of sysvinit (2.78) with some bug fixes
* Thu Dec 16 1999 - werner@suse.de
- New version of killproc 1.13
  * Bug fix in handling hard links for daemons using pid files
  * Bug fix: PROC pointers should not be volatile
  * Shorten nonsleeps for none daemon programs
* Tue Nov 09 1999 - werner@suse.de
- Avoid trouble with hard links of binaries
* Sun Nov 07 1999 - kukuk@suse.de
- mingetty: Add 1900 to tm_year, it contains the years since 1900.
* Wed Nov 03 1999 - werner@suse.de
- New killproc 1.12
  * Fix option -q of startproc
  * Fix Bug in wait4 handling of startproc
  * Fix script detection: do not handle startproc, killproc, and
  checkproc as script interpreters
* Mon Nov 01 1999 - werner@suse.de
- Add a patch from Marius
* Fri Oct 29 1999 - werner@suse.de
- powerd should tell init if status is OK again
* Thu Sep 30 1999 - werner@suse.de
- New killproc version 1.11
  * Some small speedups
  * Minor spell correction in the manual pages
  * Allow login onto tty's
- Use RPM_OPT_FLAGS throughout
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Tue Sep 07 1999 - werner@suse.de
- Enable mingetty resetting the terminal
* Fri Aug 06 1999 - werner@suse.de
- New killproc-1.10
  * startproc which is able to sleep
  * better zombie handling
- killproc doesn't ignore zombies
- checkproc ignores zombies without `-z' by default
- startproc checks zombie state of child while sleeping
* Tue Jul 06 1999 - werner@suse.de
- Fix pts problem of shutdown (dowall.c)
* Thu Jun 24 1999 - werner@suse.de
- Add lastb and its manual page
* Wed Jun 23 1999 - werner@suse.de
- Integrate newest mingetty patch of jurix
- Update killproc version 1.9
  * be more sufficient in setting user and/or group id
- Update to sysvinit 2.76
  * Integrate newest sysvinit patch of jurix into
  our patch. The command last is part of sysvinit.
* Tue Jun 22 1999 - werner@suse.de
- Update to new killproc version 1.8
  * startproc knows about setsid to set up a new process session
  for the new task (option -s)
  * startproc can change the effective uid and/or gid for a process
  (option -u uid and/or -g gid)
- Make spec file more handy for newer versions.
* Mon May 03 1999 - werner@suse.de
- Enable killproc-1.7.dif in specs file
* Mon May 03 1999 - werner@suse.de
- killproc shouldn't complain a disappeared job/thread
* Mon Apr 19 1999 - werner@suse.de
- mingetty: reset not only /dev/tty<line> but /dev/vcs<line> and
  /dev/vcsa<line> also
* Fri Feb 26 1999 - werner@suse.de
- New killproc vesion 1.7
  * read of /proc/ is secure against EINTR
  * handle script names ala `bash -x /usr/bin/myscript -y'
* Mon Jan 18 1999 - werner@suse.de
- Make killproc more smart, e.g. faster
- Make startproc alpah compatible
* Thu Dec 10 1998 - ro@suse.de
- added last manpage
- link init static
* Tue Dec 08 1998 - ro@suse.de
- use last from sysvinit-2.75
* Mon Nov 30 1998 - werner@suse.de
- Close some races, unknowns, and difficulties in killproc tools
* Tue Nov 24 1998 - werner@suse.de
- Don't blame boot script with killproc having same name as the
  controlled daemon ... new kernel doesn't need this.
* Mon Nov 16 1998 - ro@suse.de
- install man-page for powerd
* Fri Nov 13 1998 - werner@suse.de
- Integrate powerd-2.0 for a replacment of the obsolate old one
* Mon Nov 02 1998 - ro@suse.de
- update to killproc-1.6
* Thu Oct 22 1998 - ro@suse.de
- update to killproc-1.5  (take 2)
* Thu Oct 08 1998 - ro@suse.de
- killproc: libinit.c output of "can't open pid file" only "#if DEBUG"
* Tue Oct 06 1998 - ro@suse.de
- updated killproc to get rid of a memleak
* Mon Oct 05 1998 - ro@suse.de
- new version: killproc-1.4
* Fri Jul 03 1998 - werner@suse.de
- added killproc-1.2, a replacement of the old killproc
* Wed May 06 1998 - florian@suse.de
- added an option to killproc to also kill process groups:
  killproc [-SIG] [-g] prog
* Tue Nov 04 1997 - mantel@suse.de
- creation of dev/initctl fixed
* Thu Oct 23 1997 - ro@suse.de
- ready for autobuild
